#include "stdafx.h"
#include "NetDemo.h"
#include "DlgCloudDev.h"
#include "DlgCloudVMSList.h"
#include <string>

IMPLEMENT_DYNAMIC(CDlgCloudDev, CDialog)

CDlgCloudDev::CDlgCloudDev(CWnd* pParent /*=NULL*/)
    : CDialog(CDlgCloudDev::IDD, pParent)
    ,m_strUrl("")
    ,m_strUsername("")
    ,m_strPassword("")
    , m_udwCloudDevType(0)
{

}

CDlgCloudDev::~CDlgCloudDev()
{
}

void CDlgCloudDev::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_EDIT_CLOUD_URL, m_strUrl);
    DDX_Text(pDX, IDC_EDIT_CLOUD_USERNAME, m_strUsername);
    DDX_Text(pDX, IDC_EDIT_CLOUD_PASSWD, m_strPassword);
    DDX_Control(pDX, IDC_COMBO_CLOUD_DEVICE_TYPE, m_oDeviceType);
    DDX_CBIndex(pDX, IDC_COMBO_CLOUD_DEVICE_TYPE, m_udwCloudDevType);
}


BEGIN_MESSAGE_MAP(CDlgCloudDev, CDialog)
    ON_BN_CLICKED(IDC_BUTTON_CLOUD_SAVE, &CDlgCloudDev::OnBnClickedButtonCloudSave)
    ON_BN_CLICKED(IDC_BUTTON_CLOUD_CANCEL, &CDlgCloudDev::OnBnClickedButtonCloudCancel)
END_MESSAGE_MAP()



BOOL CDlgCloudDev::OnInitDialog()
{
    CDialog::OnInitDialog();
    InitCombo();
    m_oDlgCloudVMSList.Create(IDD_DIALOG_CLOUD_VMS_LIST,this);

    return TRUE;
}

void CDlgCloudDev::InitCombo()
{
    m_oDeviceType.InsertString(0,_T("IPC/ NVR"));
    m_oDeviceType.InsertString(1,_T("VMS"));
    m_oDeviceType.SetCurSel(0);

    return;
}

void CDlgCloudDev::OnBnClickedButtonCloudSave()
{
    NETDEMO_DEVICE_INFO stNetDevinfo;
    UpdateData(TRUE);

    CHAR szUrlTmp[NETDEV_LEN_260] = {0};
    for (UINT32 i = 0, j = 0; i < m_strUrl.GetLength(); i++)
    {
        if (' ' != m_strUrl[i])
        {
            szUrlTmp[j] = m_strUrl[i];
            j++;
        }
    }

    if ((0 == strlen(szUrlTmp))
        || (NETDEV_LEN_260 <= strlen(szUrlTmp))
        || (0 == m_strUsername.GetLength())
        || (NETDEV_LEN_64 <= m_strUsername.GetLength())
        || (0 == m_strPassword.GetLength())
        || (NETDEV_LEN_64 <= m_strPassword.GetLength()))
    {
        NETDEMO_LOG_ERROR(NULL, "Cloud Server Para is invalid");
        return;
    }

    //for (int i = 0; i < NETDEMO_MAX_DEVICES; i++)
    //{
    //    std::string strCloudName = gastDeviceInfo[i].szCloudName;
    //    std::string strCloudPwd = gastDeviceInfo[i].szCloudPasswd;
    //    std::string strCloudUrl = gastDeviceInfo[i].szCloudUrl;

    //    if (strCloudUrl == m_strUrl.GetString() &&
    //        strCloudName == m_strUsername.GetString() &&
    //        strCloudPwd == m_strPassword.GetString())
    //    {
    //        NETDEMO_LOG_ERROR(NULL, "Login Cloud exit.");
    //        return ;
    //    }
    //}

    LPVOID  lpCloudHandle= NETDEV_LoginCloud(szUrlTmp, m_strUsername.GetBuffer(0), m_strPassword.GetBuffer(0));
    if(NULL == lpCloudHandle)
    {
        NETDEMO_LOG_ERROR(NULL, "Login Cloud Failed, please check your URL, username and password.");
        return;
    }

    stNetDevinfo.lpCloudHandle = lpCloudHandle;
    stNetDevinfo.dwLoginType = NETDEMO_LOGTYPE_CLOUD;
    strncpy(stNetDevinfo.szCloudUrl, szUrlTmp, sizeof(stNetDevinfo.szCloudUrl) - 1);
    strncpy(stNetDevinfo.szCloudName, m_strUsername.GetBuffer(0), sizeof(stNetDevinfo.szCloudName) - 1);
    strncpy(stNetDevinfo.szCloudPasswd, m_strPassword.GetBuffer(0), sizeof(stNetDevinfo.szCloudPasswd) - 1);

    if (1 == m_udwCloudDevType)//1ʾ¼VMS
    {
        gastLoginDeviceInfo.pCloudHandle = lpCloudHandle;
        strncpy(gastLoginDeviceInfo.stNETDEV_LoginInfo.szCloudUrl, stNetDevinfo.szCloudUrl, sizeof(stNetDevinfo.szCloudUrl) - 1);
        strncpy(gastLoginDeviceInfo.stNETDEV_LoginInfo.szCloudName, stNetDevinfo.szCloudName, sizeof(stNetDevinfo.szCloudName) - 1);
        strncpy(gastLoginDeviceInfo.stNETDEV_LoginInfo.szCloudPasswd, stNetDevinfo.szCloudPasswd, sizeof(stNetDevinfo.szCloudPasswd) - 1);
        stNetDevinfo.stCloudDevinfo.dwDevType = NETDEV_CLOUD_DEV_TYPE_VMS;
        GetParent()->SendMessage(WM_ADD_DEVICE,WPARAM(NETDEMO_LOGTYPE_CLOUD),(LPARAM)&stNetDevinfo);
        EndDialog(-1);

    }
    else
    {
        GetParent()->SendMessage(WM_ADD_DEVICE,WPARAM(NETDEMO_LOGTYPE_CLOUD),(LPARAM)&stNetDevinfo);
        CDialog::OnOK();
    }
}

void CDlgCloudDev::OnBnClickedButtonCloudCancel()
{
    EndDialog(-1);
}
