// DlgCloudVMSList.cpp : ʵļ
//

#include "stdafx.h"
#include "NetDemo.h"
#include "DlgCloudVMSList.h"



// CDlgCloudVMSList Ի

IMPLEMENT_DYNAMIC(CDlgCloudVMSList, CDialog)

#define COL_DEV_INDEX              0
#define COL_DEV_DEVICENAME         1
#define COL_DEV_IP_ADDRESS         2
#define COL_DEV_DEV_USERNAME       3
#define COL_DEV_ISONLINE           4

class CDevCloudInfo
{
public:
       CDevCloudInfo();
       virtual ~CDevCloudInfo() {}

public:
    //std::string szIPAddr;
    
};

void CDlgCloudVMSList::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LIST_VMS_DEV_LIST, m_oCloudVMSList);
}


BEGIN_MESSAGE_MAP(CDlgCloudVMSList, CDialog)
    ON_BN_CLICKED(IDC_BUTTON_LOGIN_VMS_REFRESH, &CDlgCloudVMSList::OnBnClickedButtonLoginVmsRefresh)
    ON_BN_CLICKED(IDC_BUTTON_LOGIN_VMS, &CDlgCloudVMSList::OnBnClickedButtonLoginVms)
    ON_BN_CLICKED(IDC_BUTTON_CANCLE, &CDlgCloudVMSList::OnBnClickedButtonCancle)
END_MESSAGE_MAP()


// CDlgCloudVMSList Ϣ

void CDlgCloudVMSList::initCloudVMSList()
{
    CString str ="Index";
    m_oCloudVMSList.InsertColumn(0,str, LVCFMT_CENTER,50);

    str ="DevName";
    m_oCloudVMSList.InsertColumn(1,str,LVCFMT_CENTER,110);

    str = "IPAddress";
    m_oCloudVMSList.InsertColumn(2, str, LVCFMT_CENTER, 100);

    str = "DevUserName";
    m_oCloudVMSList.InsertColumn(3, str, LVCFMT_CENTER, 80);

    str = "IsOnline";
    m_oCloudVMSList.InsertColumn(4, str, LVCFMT_CENTER, 80);

    m_oCloudVMSList.SetExtendedStyle(m_oCloudVMSList.GetExtendedStyle()|LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT|LVS_EX_SUBITEMIMAGES);

    return;
}

BOOL CDlgCloudVMSList::OnInitDialog()
{
    CDialog::OnInitDialog();

    // TODO: ڴ˴Ϣ
    initCloudVMSList();

    return TRUE;
}

void CDlgCloudVMSList::OnBnClickedButtonLoginVmsRefresh()
{
    UpdateData(TRUE);
    m_oCloudVMSList.DeleteAllItems();
    m_oCloudDevBasicInfoList.clear();
    // TODO: ڴӿؼ֪ͨ
    LPVOID lpDevListHandle = NETDEV_FindCloudDevListEx(gastLoginDeviceInfo.pCloudHandle);

    if(NULL == lpDevListHandle)
    {
        NETDEMO_LOG_ERROR(NULL, "Query cloud device list");
    }

    NETDEV_CLOUD_DEV_BASIC_INFO_S stCloudDevInfo = {0};

    while(NETDEV_FindNextCloudDevInfoEx(lpDevListHandle, &stCloudDevInfo))
    {
        if (NETDEV_CLOUD_DEV_TYPE_VMS == stCloudDevInfo.dwDevType)
        {
            UTF8ToMB(stCloudDevInfo.szDevName, stCloudDevInfo.szDevName, sizeof(stCloudDevInfo.szDevName) - 1);
            m_oCloudDevBasicInfoList.push_back(stCloudDevInfo);
        }
    }

    BOOL bRet = NETDEV_FindCloseCloudDevListEx(lpDevListHandle);
    if (TRUE != bRet)
    {
        return;
    }

    std::list<NETDEV_CLOUD_DEV_BASIC_INFO_S>::iterator oIt = m_oCloudDevBasicInfoList.begin();
    for(INT32 i = 0 ; oIt != m_oCloudDevBasicInfoList.end(); oIt++,i++)
    {
        INT32 dwRow = m_oCloudVMSList.InsertItem(i, "");
        CHAR szBuf[64];
        _snprintf(szBuf, sizeof(szBuf), "%d", i+1);
        m_oCloudVMSList.SetItemText(i, COL_DEV_INDEX, szBuf);

        m_oCloudVMSList.SetItemText(i, COL_DEV_DEVICENAME, oIt->szDevName);

        m_oCloudVMSList.SetItemText(i, COL_DEV_IP_ADDRESS, oIt->szIPAddr);

        m_oCloudVMSList.SetItemText(i, COL_DEV_DEV_USERNAME, oIt->szDevUserName);

        CString strIsOnline;
        if (TRUE == oIt->bKeepLiveStatus)
        {
            strIsOnline = "Online";
        }
        else
        {
            strIsOnline = "Disonline";
        }

        m_oCloudVMSList.SetItemText(i, COL_DEV_ISONLINE, strIsOnline);

        UpdateData(TRUE);
    }
     UpdateData(TRUE);
    return;
}

void CDlgCloudVMSList::OnBnClickedButtonLoginVms()
{
    // TODO: ڴӿؼ֪ͨ
    POSITION pos = m_oCloudVMSList.GetFirstSelectedItemPosition();
    if (pos > 0)
    {
        INT32 dwItem = (int)pos - 1;
        {
            NETDEV_CLOUD_DEV_LOGIN_INFO_S stCloudInfo = {0};

            std::string strIPAddress = m_oCloudVMSList.GetItemText(dwItem, COL_DEV_IP_ADDRESS);
            std::string strCloudDevName = m_oCloudVMSList.GetItemText(dwItem, COL_DEV_DEV_USERNAME);

            strncpy(stCloudInfo.szDeviceName, strCloudDevName.c_str(), sizeof(stCloudInfo.szDeviceName) - 1);
            stCloudInfo.dwLoginProto = NETDEV_LOGIN_PROTO_PRIVATE;
            LPVOID lpCloudDevLoginHandle = NETDEV_LoginCloudDevice_V30(gastLoginDeviceInfo.pCloudHandle, &stCloudInfo);
            if (NULL == lpCloudDevLoginHandle)
            {
                UpdateData(FALSE);
                return;
            }
            gastLoginDeviceInfo.pHandle = lpCloudDevLoginHandle;
            gastLoginDeviceInfo.pCloudHandle = NULL;
            NETDEMO_LOGIN_INFO_S stNETVMSInfo;
            memset((void*)&stNETVMSInfo,0,sizeof(stNETVMSInfo));
            stNETVMSInfo.dwLoginType = NETDEMO_LOGTYPE_CLOUD;
            stNETVMSInfo.dwDevType = NETDEV_CLOUD_DEV_TYPE_VMS;
            strncpy(stNETVMSInfo.szIPAddr, strIPAddress.c_str(), sizeof(stNETVMSInfo.szIPAddr) - 1);
            strncpy(stNETVMSInfo.szCloudDevName, strCloudDevName.c_str(), sizeof(stNETVMSInfo.szCloudDevName) - 1);

            GetParent()->SendMessage(WM_ADD_CLOUD_VMS,WPARAM(NETDEMO_LOGTYPE_CLOUD),(LPARAM)&stNETVMSInfo);
            EndDialog(-1);
            return;
        }
    }
    else
    {
        NETDEMO_LOG_ERROR(NULL, "Please select one item");
        return;
    }
}
    

void CDlgCloudVMSList::OnBnClickedButtonCancle()
{
    // TODO: ڴӿؼ֪ͨ
    EndDialog(-1);
}
